#ifndef __SSSD_THREAD_H__
#define __SSSD_THREAD_H__

#include <e32base.h>
#include <mdaaudiooutputstream.h>
#include <mda/common/audio.h>
extern "C" {
#include "sssd.h"
}
#include "TAudioShared.h"


/*!
   @class CSSSDAudioOutputStream

   @discussion
        Wrapper to the CMdaAudioOutputStream
 */
class CSSSDThread : public CBase, public MMdaAudioOutputStreamCallback {


    /* ========================================================================
     * Private instance data
     */

    CTrapCleanup*			iCleanupStack;
	CActiveScheduler*		iActiveScheduler;
	CMdaAudioOutputStream*	iStream;
	TMdaAudioDataSettings	iSet;
    struct sssdaudio*       iSSSDAudio;
    TPtrC8                  iBufferPtr; // pointer to iSSSDAudio->playBuffer
	TInt					iError;		// contains CMdaAudioOutput errors

	TAudioShared&           iShared;
	TBool iStreamOpen;


    /* ========================================================================
     * Private methods
     */

    CSSSDThread(TAny *aData);
    static CSSSDThread *Create(TAny *aData);
    TInt Construct();
    void ConstructL();
    static void ExcHandler(TExcType aExc);
    void HandleException(TExcType aExc);

    void FillBufferL();
    void StartMixerL();
    void StopMixer();

	void MaoscPlayComplete( TInt aError );
	void MaoscBufferCopied( TInt aError, const TDesC8& aBuffer );
	void MaoscOpenComplete( TInt aError );


    /* ========================================================================
     * Public API
     */

public:

    static TInt ThreadFunction(TAny *aData);
    ~CSSSDThread();

};

#endif /* __SSSD_THREAD_H__ */
